// Old Photo Effect
//
// Copyright Outerspace Software, all rights reserved

string description = "This effect makes your texture look like an old sepia photo.";

//texture0: the background texture
//texture1: not used

float PI=3.14159;

float4x4	WorldViewProjection;	

texture MyTexture0;
sampler MyTextureSampler0 = sampler_state{
    Texture   = (MyTexture0);
    AddressU  = CLAMP;
    AddressV  = CLAMP;
    MipFilter = LINEAR;
    MinFilter = LINEAR;
    MagFilter = LINEAR;
};

struct VS_INPUT{
	float4 position:	POSITION;
	float3 normal:		NORMAL;
	float3 diffuse:		COLOR;
	float2 tex:			TEXCOORD0;
};

struct VS_OUTPUT{
	float4 position:	POSITION;
	float2 tex:			TEXCOORD0;
};

struct PS_OUTPUT{
    float4 color:		COLOR;
};

VS_OUTPUT VS(VS_INPUT input){
	VS_OUTPUT output;
	output.position = mul(input.position, WorldViewProjection);
	output.tex = input.tex;
	return output;
}

PS_OUTPUT PS(VS_OUTPUT input){
	PS_OUTPUT output;

	float2 t=input.tex;

	float4 r=tex2D(MyTextureSampler0, t);
	
	float g=(r.x+r.y+r.z)/3;
	r.x=g;
	r.y=g;
	r.z=g;
	
	float4 c0=float4(51,37,2,255)/255;
	float4 c1=float4(237,240,209,255)/255;

	r=c0+g*(c1-c0);
	
	float BorderSize = 0.03;
	float Kantelen = 30;

	if(t.x<BorderSize){
		if((BorderSize*0.5+(cos(t.y*PI*Kantelen)+1)*0.25*BorderSize) > t.x) r.w=0;
	}
	if(t.x>(1-BorderSize)){
		if((BorderSize*0.5+(cos(t.y*PI*Kantelen)+1)*0.25*BorderSize) > (1-t.x)) r.w=0;
	}
	
	if(t.y<BorderSize){
		if((BorderSize*0.5+(cos(t.x*PI*Kantelen)+1)*0.25*BorderSize) > t.y) r.w=0;
	}
	if(t.y>(1-BorderSize)){
		if((BorderSize*0.5+(cos(t.x*PI*Kantelen)+1)*0.25*BorderSize) > (1-t.y)) r.w=0;
	}
		
	output.color = r;    
	return output;
}

technique Shader
{
    pass P0
    {
		Alphablendenable	=TRUE;
		SRCBLEND			=SRCALPHA;
		DESTBLEND			=INVSRCALPHA;
		    
		VertexShader	= compile vs_1_1 VS();
		PixelShader		= compile ps_2_0 PS();
    }
}
